package org.campbelli.ejb.bean;

import org.jboss.security.SimpleGroup;
import org.jboss.security.SimplePrincipal;
import org.jboss.security.auth.spi.AbstractServerLoginModule;
import org.jboss.security.auth.spi.UsernamePasswordLoginModule;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.LoginException;
import java.security.Principal;
import java.security.acl.Group;
import java.util.Map;
import java.util.Set;

public class TestLoginModule  extends UsernamePasswordLoginModule {//AbstractServerLoginModule {

    @Override
    public void initialize(Subject subject, CallbackHandler callbackHandler, Map<String, ?> sharedState, Map<String, ?> options) {
        super.initialize(subject, callbackHandler, sharedState, options);
    }

    @Override
    public boolean commit() throws LoginException {
        boolean commit = super.commit();
        return commit;
    }

    @Override
    public boolean login() throws LoginException {
        boolean login = super.login();
        return login;
    }

    @Override
    protected Principal createIdentity(String username) throws Exception {
        String[] args = username.split("\\.");
        UserToken userToken = new UserToken(username);
        userToken.setId(Long.valueOf(args[0]));
        userToken.setRole(args[1]);
        userToken.setUsername(args[2]);
        return userToken;
    }

    @Override
    protected Group createGroup(String name, Set<Principal> principals) {
        Group group = super.createGroup(name, principals);
        return group;
    }


    @Override
    protected Principal getIdentity() {
        return this.pr
    }


    @Override
    protected String getUsersPassword() throws LoginException {
        return "pass123";
    }


    @Override
    protected Group[] getRoleSets() throws LoginException {
        SimpleGroup simpleGroup = new SimpleGroup("Roles");
        simpleGroup.addMember(new SimplePrincipal("admin"));
        simpleGroup.addMember(new SimplePrincipal("test"));
        return new Group[]{simpleGroup};
    }
}
